//
//  LoaderWindowController.h
//  MobileDaxhotel
//
//  Created by Raphael Schweikert on 29.06.08.
//  Copyright 2008 sabberworm. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "DataLoader.h"

@class DataController, MobileDaxhotelAppDelegate;

@interface LoaderWindowController : UIViewController <UIAlertViewDelegate> {
    IBOutlet UIView *loaderView;
    IBOutlet UILabel *statusText;
    IBOutlet UIImageView *imageView;
    IBOutlet UIActivityIndicatorView *infiniteProgressView;
    IBOutlet UIProgressView *incrementalProgressView;
    float incrementalProgressViewMax;
    float incrementalProgressViewCurrent;
    IBOutlet MobileDaxhotelAppDelegate *appDelegate;
    BOOL isActive;
}

@property (nonatomic,assign) BOOL isActive;

- (void)activate;
- (void)deactivate;
- (void)loadData:(DataController *)dataController status:(DAXHOTEL_DB_STATUS) status;
-(void)displayConnectionLostAlert;
- (void)displayLoadingText:(NSString *)text image:(UIImage *)image contentMode:(UIViewContentMode)contentMode;
- (void)switchToIncrementalModeMax:(float)max;
- (void)increment;
- (void)finishedLoading:(DataLoader *)dataLoader;

@end
