//
//  LoaderWindowController.m
//  MobileDaxhotel
//
//  Created by Raphael Schweikert on 29.06.08.
//  Copyright 2008 sabberworm. All rights reserved.
//

#import "LoaderWindowController.h"
#import "MobileDaxhotelAppDelegate.h"

@implementation LoaderWindowController

@synthesize isActive;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        isActive=NO;
    }
    return self;
}

- (void)activate {
    [[UIApplication sharedApplication] setStatusBarStyle:UIStatusBarStyleBlackTranslucent animated:YES];
    [UIApplication sharedApplication].networkActivityIndicatorVisible = YES;
    [UIApplication sharedApplication].idleTimerDisabled = YES;
    loaderView.frame=appDelegate.mainWindow.frame;
    [appDelegate.mainWindow addSubview:loaderView];
    isActive=YES;
}

- (void)deactivate {
    [[UIApplication sharedApplication] setStatusBarStyle:UIStatusBarStyleDefault animated:YES];
    [UIApplication sharedApplication].networkActivityIndicatorVisible = NO;
    [UIApplication sharedApplication].idleTimerDisabled = NO;
    [loaderView removeFromSuperview];
    isActive=YES;
}

- (void)viewDidLoad {
    
}


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}

- (void)dealloc {
    [super dealloc];
}

- (void)loadData:(DataController *)dataController status:(DAXHOTEL_DB_STATUS) status {
    DataLoader *dataLoader = [[DataLoader alloc] initWithData:dataController controller:self status:status];
    [dataLoader start];
}

- (void)displayConnectionLostAlert {
    [[[UIAlertView alloc] initWithTitle:NSLocalizedString(@"lostNetworkTitle", @"Network Connection Lost") message:NSLocalizedString(@"lostNetworkText", @"Lost Network Connection@") delegate:self cancelButtonTitle:NSLocalizedString(@"noDataButtonQuit", @"Quit") otherButtonTitles:nil] show];
}

//Exit when the alert is dismissed
- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex {
    [[UIApplication sharedApplication] terminateWithSuccess];
}

- (void) displayLoadingText:(NSString *)text image:(UIImage *)image contentMode:(UIViewContentMode)contentMode {
    [statusText setText:text];
    [imageView setImage:image];
    [imageView setContentMode: contentMode];
}

- (void)switchToIncrementalModeMax:(float)max {
    [infiniteProgressView setHidden:YES];
    [incrementalProgressView setHidden:NO];
    incrementalProgressViewMax=max;
    incrementalProgressViewCurrent=0.0;
}

- (void)increment {
    incrementalProgressViewCurrent++;
    [incrementalProgressView setProgress:(incrementalProgressViewCurrent/incrementalProgressViewMax)];
}

- (void)finishedLoading:(DataLoader *)dataLoader {
    [dataLoader cancel];
    [dataLoader release];
    [appDelegate finishedLoading];
}

@end
