//
//  SearchResultViewController.m
//  MobileDaxhotel
//
//  Created by Raphael Schweikert on 31.03.09.
//  Copyright 2009 Raphael Schweikert. All rights reserved.
//

#import "SearchResultViewController.h"
#import "SearchEpisodeSelectionTableController.h"
#import "MobileDaxhotelAppDelegate.h"

@implementation SearchResultViewController

@synthesize appDelegate;

// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
    searchEpisodeSelectionTableController = [[SearchEpisodeSelectionTableController alloc] init];
    searchEpisodeSelectionTableController.appDelegate = self.appDelegate;
    self.view = searchEpisodeSelectionTableController.view;
    bar = [[UISearchBar alloc] initWithFrame:CGRectMake(0.0f, 0.0f, self.view.frame.size.width, 44.0f)];
    bar.autocorrectionType = UITextAutocorrectionTypeNo;
    bar.autocapitalizationType = UITextAutocapitalizationTypeNone;
    [bar setDelegate: self];
//    [self.view addSubview: bar];
    searchEpisodeSelectionTableController.tableView.tableHeaderView = bar;
    [bar becomeFirstResponder];
    self.navigationItem.title = NSLocalizedString(@"searchTitle", @"searchTitle");
}

- (void)searchBarSearchButtonClicked:(UISearchBar *)searchBar {
    if([searchBar.text isEqual:previousSearchString]) {
        [searchBar resignFirstResponder];
        [searchEpisodeSelectionTableController scrollToTop];
        return;
    }
    if([searchBar.text length] < 3) {
        [[[[UIAlertView alloc] initWithTitle:nil message:NSLocalizedString(@"searchStringTooShort", @"Search string too short") delegate:nil cancelButtonTitle:NSLocalizedString(@"OK", @"OK") otherButtonTitles:nil] autorelease] show];
        return;
    }
    searchEpisodeSelectionTableController.displayedEpisodes = [[[appDelegate dataController] episodesBySearchString:searchBar.text] autorelease];
    [searchEpisodeSelectionTableController updateTable];
    if([searchEpisodeSelectionTableController.displayedEpisodes count] == 0) {
        [[[[UIAlertView alloc] initWithTitle:nil message:NSLocalizedString(@"noEpisodesFound", @"No episodes found") delegate:nil cancelButtonTitle:NSLocalizedString(@"OK", @"OK") otherButtonTitles:nil] autorelease] show];
    } else {
        [previousSearchString release];
        previousSearchString = [searchBar.text retain];
        [searchBar resignFirstResponder];
    }
}

- (void) viewWillAppear:(BOOL)animated {
    [[[self navigationController] navigationBar] setTintColor:nil];
}

- (void) viewDidAppear:(BOOL)animated {
    [searchEpisodeSelectionTableController deselect];
}

- (void) cleanup {
    [bar setText:@""];
    [previousSearchString release];previousSearchString=nil;
    searchEpisodeSelectionTableController.displayedEpisodes = nil;
    [searchEpisodeSelectionTableController updateTable];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (void)viewDidUnload {
    [self cleanup];
}

- (void)dealloc {
    [bar release]; bar=nil;
    [searchEpisodeSelectionTableController release]; searchEpisodeSelectionTableController=nil;
    [super dealloc];
}


@end
